#!/bin/sh

# shortkey2.sh
# Short Key Attack Demo
# by Javantea

short_key=000000000000000000000000f41f4277
num=1
echo "File: test1_$num.tar.bf Key: $short_key"

openssl enc -bf-cbc -K $short_key -iv 0000000000000 -in test1.tar -out test1_$num.tar.bf

dd if=test1_1.tar.bf of=test1_1.tar.bf.1 bs=1024 count=1

test_key=00000000000000000000000000000000
echo "$test_key ${test_key:${#test_key}-4:${#test_key}}"
while [ 1 ]; do
	openssl enc -bf-cbc -d -K $test_key -iv 0000000000000 -in test1_1.tar.bf.1 | check_tar
	if [ $? == 0 ]; then
		echo "Possible match found: $test_key"
		break
	fi
	if [ "${test_key:${#test_key}-4:${#test_key}}" == "0000" ]; then
		echo $test_key
	fi
	test_key=`increment -x $test_key`
done 2> /dev/null

